from collections import deque

def main():
    n, m, k = map(int, input().split())
    
    graph = [[] for _ in range(n + 1)]
    
    for _ in range(m):
        a, b = map(int, input().split())
        graph[a].append(b)
        graph[b].append(a)
    
    g = set()
    
    for _ in range(k):
        p, h = map(int, input().split())
        
        visited = [False] * (n + 1)
        q = deque([(p, 0)])  # (node, depth)
        visited[p] = True
        
        while q:
            c, d = q.popleft()
            
            if d > h:
                continue
            
            g.add(c)
            
            for r in graph[c]:
                if not visited[r]:
                    visited[r] = True
                    q.append((r, d + 1))
    
    print(len(g))
    if g:
        result = sorted(g)
        print(" ".join(map(str, result)))
    else:
        print()

if __name__ == "__main__":
    main()
